﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint.WebControls;
using System.Collections.Generic;
using System.Reflection;
using Microsoft.SharePoint;

namespace Chapter3.ControlTemplates.Chapter3
{
  public partial class CustomRibbonHeader : UserControl,IPostBackEventHandler
  {
    public void RaisePostBackEvent(string eventArgument)
    {     
      SPRibbonPostBackEvent pbEvent = SPRibbonPostBackCommand.DeserializePostBackEvent(eventArgument);
      SPContext.Current.List.Title = "Updated " + DateTime.Now;
      SPContext.Current.List.Update();
    }

    protected override void OnPreRender(EventArgs e)
    {
      List<IRibbonCommand> commands = new List<IRibbonCommand>();
      commands.Add(new SPRibbonPostBackCommand("Chapter3.HelloWorldServerCommand", this, "true"));

      SPRibbonScriptManager sm = new SPRibbonScriptManager();

      sm.RegisterGetCommandsFunction(this.Page, "getGlobalCommands", commands);
      sm.RegisterCommandEnabledFunction(this.Page, "canHandleCommand", commands);
      sm.RegisterHandleCommandFunction(this.Page, "handleCommand", commands);   
    }
  }  
}
