﻿Type.registerNamespace('Chapter3.PageComponent');

Chapter3.PageComponent = function () {
    Chapter3.PageComponent.initializeBase(this);
}

Chapter3.PageComponent.initialize = function () {
    ExecuteOrDelayUntilScriptLoaded(Function.createDelegate(null, Chapter3.PageComponent.initializePageComponent), 'SP.Ribbon.js');
}

Chapter3.PageComponent.initializePageComponent = function () {
    var ribbonPageManager = SP.Ribbon.PageManager.get_instance();
    if (null !== ribbonPageManager) {
        ribbonPageManager.addPageComponent(Chapter3.PageComponent.instance);
    }
}

Chapter3.PageComponent.refreshRibbonStatus = function () {
    SP.Ribbon.PageManager.get_instance().get_commandDispatcher().executeCommand(Commands.CommandIds.ApplicationStateChanged, null);
}

Chapter3.PageComponent.prototype = {
    init: function () { },
    getFocusedCommands: function () {return [''];},
    isFocusable: function () { return true; },
    receiveFocus: function () { return true; },
    yieldFocus: function () { return true; },
    getGlobalCommands: function () {
        var commands = getGlobalCommands();
        return commands.concat(['Chapter3.HelloWorldCommand']);   
    },
    canHandleCommand: function (commandId) {
        if (commandId == 'Chapter3.HelloWorldCommand') {
            return true;
        }
        else {
            return commandEnabled(commandId);
        }
    },
    handleCommand: function (commandId, properties, sequence) {
        if (commandId === 'Chapter3.HelloWorldCommand') {
            var notificationId = SP.UI.Notify.addNotification('Hello World from page component');
        }
        else {
            return handleCommand(commandId, properties, sequence);
        }
    }    
}

Chapter3.PageComponent.registerClass('Chapter3.PageComponent', CUI.Page.PageComponent);
Chapter3.PageComponent.instance = new Chapter3.PageComponent();
NotifyScriptLoadedAndExecuteWaitingJobs("Chapter3.PageComponent.js");
