﻿/// <reference path="C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\14\TEMPLATE\LAYOUTS\MicrosoftAjax.js" />
/// <reference path="C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\14\TEMPLATE\LAYOUTS\SP.debug.js" />
/// <reference path="C:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\14\TEMPLATE\LAYOUTS\SP.UI.Dialog.debug.js" />

function Button_Click() {
    var ctx = new SP.ClientContext.get_current();
    var web = ctx.get_web();
    ctx.load(web);
    ctx.executeQueryAsync(function (s, args) {
        var console = document.getElementById('DemoConsole');
        console.innerHTML = "Title:" + web.get_title()
                        + ", Description:" + web.get_description();
    },
    null);
}

function CAMLQuery_Click() {
    var ctx = new SP.ClientContext.get_current();
    var query = new SP.CamlQuery();
    query.viewXml = "<View><Query><OrderBy><FieldRef Name=\"Editor\" Ascending=\"False\" /></OrderBy></Query></View>";
    var announcements = ctx.get_web().get_lists().getByTitle("Announcements");
    var listItems = announcements.getItems(query);
    ctx.load(listItems);
    var fields = announcements.get_fields();
    ctx.load(fields);
    ctx.executeQueryAsync(function (s, args) {
        var console = document.getElementById('DemoConsole');
        console.innerHTML = buildTable(fields, listItems);
    }, null);
}

function buildTable(fields, listItems) {
    var output = "";
    output = "<table><thead style=\"font-weight:bold\"><tr>";
    var fieldEnum = fields.getEnumerator();
    while (fieldEnum.moveNext()) {
        var field = fieldEnum.get_current();
        if (field.get_hidden() != true) {
            output += "<td>" + field.get_title() + "</td>";
        }
    }
    output += "</tr></thead>";
    var enumerator = listItems.getEnumerator();
    while (enumerator.moveNext()) {
        var item = enumerator.get_current();
        fieldEnum.reset();
        output += "<tr>";
        while (fieldEnum.moveNext()) {
            var field = fieldEnum.get_current();
            if (field.get_hidden() != true) {
                try {
                    output += "<td>" + item.get_item(field.get_staticName()) + "</td>";
                } catch (e) {
                    output += "<td>--</td>";
                }
            }
        }
        output += "</tr>";
    }
    output += "</table>"
    return output;
}

function StatusBarUpdate_Click() {

    SP.UI.Status.removeAllStatus(true);

    var sid = SP.UI.Status.addStatus("My New Status:", "Information Message", true);

    window.setTimeout(function () { UpdateStatusBar("D", "red", sid) }, 1000);
    window.setTimeout(function () { UpdateStatusBar("D I", "green", sid) }, 2000);
    window.setTimeout(function () { UpdateStatusBar("D I S", "blue", sid) }, 3000);
    window.setTimeout(function () { UpdateStatusBar("D I S C", "yellow", sid) }, 4000);
    window.setTimeout(function () { UpdateStatusBar("D I S C O", "green", sid) }, 5000);
    window.setTimeout(function () { SP.UI.Status.removeStatus(sid) }, 6000);
}

function UpdateStatusBar(message, color, sid) {

    SP.UI.Status.updateStatus(sid, message);
    SP.UI.Status.setStatusPriColor(sid, color);
}


//function SendNotification_Click() {
//    var nid=SP.UI.Notify.addNotification("My New notification", false);
//}

var nid;

function SendNotification_Click() {

    if (nid == null) {
        nid = SP.UI.Notify.addNotification("My New notification <a href='Javascript:hideNotification_Click();'>Click Me</a>", true);
    }
}

function hideNotification_Click() {
    SP.UI.Notify.removeNotification(nid);
    nid = null;
}

function ShowDialog_Click() {

 var options = {url: 'http://www.chaholl.com',tite: 'My Dialog',
                allowMaximize: false,showClose: true,
                width: 150,height: 150,
                dialogReturnValueCallback: SendNotification_Click};
            var did = SP.UI.ModalDialog.showModalDialog(options);           
}