﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;

namespace TranslatorServiceApplicationDemo
{
  [System.Runtime.InteropServices.Guid("C9DD4A67-47FB-11D2-83E7-00C04F9902C1")]
  public sealed class TranslationService : SPIisWebService, IServiceAdministration
  {
    private static TranslationService _local = null;

    public TranslationService()
    { }

    public TranslationService(SPFarm farm)
      : base(farm)
    {
      this.Name = "TranslationService";
    }

    public static TranslationService Local
    {
      get
      {
        if (TranslationService._local == null)
        {
          TranslationService._local = SPFarm.Local.Services.GetValue<TranslationService>("TranslationService");
        }

        return TranslationService._local;
      }
    }

    public override SPAdministrationLink GetCreateApplicationLink(Type serviceApplicationType)
    {
      return new SPAdministrationLink("/_admin/TranslationDemo/TranslationServiceCreate.aspx");
    }

    internal TranslationServiceApplication GetWebApplicationByName(string applicationName)
    {      
      return base.Applications.GetValue<TranslationServiceApplication>(applicationName);
    }

    public SPServiceApplication CreateApplication(string name, Type serviceApplicationType, SPServiceProvisioningContext provisioningContext)
    {
      throw new NotImplementedException();
    }

    public SPServiceApplication CreateApplication(string name, SPIisWebServiceApplicationPool applicationPool)
    {
      return new TranslationServiceApplication(name, this, applicationPool);
    }

    public SPServiceApplicationProxy CreateProxy(string name, SPServiceApplication serviceApplication, SPServiceProvisioningContext provisioningContext)
    {
      TranslationServiceProxy serviceProxy = CreateServiceProxy();

      return new TranslationServiceApplicationProxy(name, serviceProxy, (TranslationServiceApplication)serviceApplication);
    }
    
    public SPPersistedTypeDescription GetApplicationTypeDescription(Type serviceApplicationType)
    {
      return new SPPersistedTypeDescription(
          "Translation Service Application",
          "Demonstration Translation Service application.");
    }

    public Type[] GetApplicationTypes()
    {
      return new Type[] { typeof(TranslationServiceApplication) };
    }

    private TranslationServiceProxy CreateServiceProxy()
    {
      TranslationServiceProxy serviceProxy = (TranslationServiceProxy)base.Farm.GetObject(string.Empty, base.Farm.Id, typeof(TranslationServiceProxy));
      if (serviceProxy == null)
      {
        serviceProxy = new TranslationServiceProxy(base.Farm);
        serviceProxy.Update(true);
      }
      return serviceProxy;
    }
  }
}
