﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint;

namespace TranslatorServiceApplicationDemo
{
  [System.Runtime.InteropServices.Guid("0B42E5CF-B5BC-438C-997F-996E61CE572C")]
  class TranslationServiceApplicationProxy : SPIisWebServiceApplicationProxy
  {
    TranslationServiceApplication _application;

    public TranslationServiceApplicationProxy()
    {
    }

    public TranslationServiceApplicationProxy(string name, SPIisWebServiceProxy serviceProxy, Uri serviceEndpointUri)
      : base(name, serviceProxy, serviceEndpointUri)
    {

    }

    internal TranslationServiceApplicationProxy(string name, SPIisWebServiceProxy serviceProxy, TranslationServiceApplication serviceApplication)
      : base(name, serviceProxy, serviceApplication.Uri)
    {
      this._application = serviceApplication;
    }

    public TranslationServiceApplication TranslationApplication
    {
      get
      {
        TranslationServiceApplication app = _application;
        if (app == null)
        {
          app = TranslationServiceApplication.GetLocalApplicationByName(this.Name);
        }

        return app;
      }
    }

    public override string TypeName
    {
      get
      {
        return "Translation Service Application Proxy";
      }
    }
  }
}
